/* Gribouy : A type1 font editor
 * Copyright (C) 2003  David BOUCHER
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __GRIBOUY_BG_H__
#define __GRIBOUY_BG_H__

#include <gnome.h>
#include <gdk/gdk.h>
#include <gtk/gtkobject.h>
#include <libgnomecanvas/libgnomecanvas.h>

#include "gribouy-letter.h"
#include "gribouy-cursor.h"

#define GRIBOUY_TYPE_BG	(gribouy_bg_get_type())
#define GRIBOUY_BG(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_bg_get_type(), GribouyBg)
#define GRIBOUY_BG_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_bg_get_type(), GribouyBg const)
#define GRIBOUY_BG_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), gribouy_bg_get_type(), GribouyBgClass)
#define GRIBOUY_IS_BG(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gribouy_bg_get_type ())

#define GRIBOUY_BG_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), gribouy_bg_get_type(), GribouyBgClass)

typedef struct _GribouyBg GribouyBg;
typedef struct _GribouyBgClass GribouyBgClass;

struct _GribouyBg {
	GribouyObject parent;
};

struct _GribouyBgClass {
	GribouyObjectClass parent_class;
};


GtkType	gribouy_bg_get_type	(void);
GribouyObject *gribouy_bg_new (GribouyLetterWindow *window, gchar *filename,
		double x, double y);
void gribouy_pixbuf_set_alpha (GdkPixbuf *pixbuf, char alpha);
GList *gribouy_bg_get_bounds (GnomeCanvasPixbuf *bg);
void optimize_bounds (GribouyObject *let, GList *curves, double affine[6]);
GList *clear_bounds (GList *lst);
char gribouy_pixbuf_get_alpha (GdkPixbuf *pixbuf);
#endif
