/* Gribouy : A type1 font editor
 * Copyright (C) 2003  David BOUCHER
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __GRIBOUY_CURSOR_H__
#define __GRIBOUY_CURSOR_H__

#include <gtk/gtkobject.h>
#include <gtk/gtksignal.h>

#include "gribouy-object.h"

#define GRIBOUY_TYPE_CURSOR	(gribouy_cursor_get_type())
#define GRIBOUY_CURSOR(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_cursor_get_type(), GribouyCursor)
#define GRIBOUY_CURSOR_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_cursor_get_type(), GribouyCursor const)
#define GRIBOUY_CURSOR_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), gribouy_cursor_get_type(), GribouyCursorClass)
#define GRIBOUY_IS_CURSOR(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gribouy_cursor_get_type ())

#define GRIBOUY_CURSOR_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), gribouy_cursor_get_type(), GribouyCursorClass)


typedef struct _GribouyCursor GribouyCursor;
typedef struct _GribouyCursorClass GribouyCursorClass;

struct _GribouyCursor {
	GribouyObject parent;
	GnomeCanvasLine *line;
	guint type:2;
};

struct _GribouyCursorClass {
	GribouyObjectClass parent_class;

};

GType gribouy_cursor_get_type (void);
GribouyObject *gribouy_cursor_new (GribouyObject *obj, double x, double y, guint type);
gboolean gribouy_is_cursor (GnomeCanvasItem *item);
#endif
