/* Gribouy : A type1 font editor
 * Copyright (C) 2003  David BOUCHER
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __GRIBOUY_CURVE_H__
#define __GRIBOUY_CURVE_H__

#include <gtk/gtkobject.h>
#include <gtk/gtksignal.h>
#include <gtk/gtkmarshal.h>
#include <libgnomecanvas/libgnomecanvas.h>

#include "gribouy-object.h"
#include "gribouy-stem.h"
#include "gribouy-type1.h"

#define GRIBOUY_TYPE_CURVE	(gribouy_curve_get_type())
#define GRIBOUY_CURVE(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_curve_get_type(), GribouyCurve)
#define GRIBOUY_CURVE_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_curve_get_type(), GribouyCurve const)
#define GRIBOUY_CURVE_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), gribouy_curve_get_type(), GribouyCurveClass)
#define GRIBOUY_IS_CURVE(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gribouy_curve_get_type ())

#define GRIBOUY_CURVE_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), gribouy_curve_get_type(), GribouyCurveClass)


typedef struct _GribouyCurve GribouyCurve;
typedef struct _GribouyCurveClass GribouyCurveClass;

struct _GribouyCurve {
	GribouyObject parent;
	int closed : 1;
//	int code;
//	ArtPoint clickpt;
};

struct _GribouyCurveClass {
	GribouyObjectClass parent_class;

//	void (*changed) (GribouyCurve *curve);
};

GtkType gribouy_curve_get_type (void) G_GNUC_CONST;
GribouyObject *gribouy_curve_new (GribouyObject *letter);
void gribouy_curve_update_parent (GribouyObject *obj);
void gribouy_curve_curveto (GribouyCurve *curve, double x1, double y1,
		double x2, double y2, double x3, double y3);
void gribouy_curve_append_point (GribouyCurve *curve, ArtPoint *point);
gboolean gribouy_curve_is_closed (GribouyCurve *curve);

GnomeCanvasItem *gribouy_curve_new_with_art (GnomeCanvasGroup *group,
		gpointer prog, GribouyType1 *font);
GList *gribouy_curve_save (GribouyCurve *curve, GribouyType1 *font);
void gribouy_curve_clear (GnomeCanvasItem *item);
void gribouy_curve_link (GribouyCurve *curve, ArtPoint *point, gboolean v);
void gribouy_curve_erase_selection (GribouyCurve *curve);
void gribouy_curve_create_triplets (GribouyCurve *curve);
void gribouy_curve_move_triplets (GribouyCurve *curve, double x, double y);
void gribouy_curve_erase_triplets (GribouyCurve *curve);
GribouyObject *gribouy_curve_get_triplet_index (GribouyCurve *curve,
		gint index);
#endif
