/* Gribouy : A type1 font editor
 * Copyright (C) 2003  David BOUCHER
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __GRIBOUY_GRID_H__
#define __GRIBOUY_GRID_H__

#include <libgnomecanvas/libgnomecanvas.h>
#include "gribouy-letter-window.h"
#include <math.h>

#define GRIBOUY_TYPE_GRID	(gribouy_grid_get_type())
#define GRIBOUY_GRID(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_grid_get_type(), GribouyGrid)
#define GRIBOUY_GRID_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_grid_get_type(), GribouyGrid const)
#define GRIBOUY_GRID_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), gribouy_grid_get_type(), GribouyGridClass)
#define GRIBOUY_IS_GRID(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gribouy_grid_get_type ())

#define GRIBOUY_GRID_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), gribouy_grid_get_type(), GribouyGridClass)

typedef struct _GribouyGrid GribouyGrid;
typedef struct _GribouyGridClass GribouyGridClass;

struct _GribouyGrid {
	GnomeCanvasGroup parent;
	GribouyLetterWindow *window;
	GnomeCanvasGroup *grid;
	GnomeCanvasLine *width_bar;
	GnomeCanvasBpath *path;
	int grid_x, grid_y;
	double x1, y1, x2, y2;
	guint width;
	int left;
	guint visible : 1;
	guint magnetic : 1;
};

struct _GribouyGridClass {
	GnomeCanvasGroupClass parent_class;
};


GType gribouy_grid_get_type (void) G_GNUC_CONST;
GnomeCanvasItem *gribouy_grid_new (GribouyLetterWindow *window,
		GArray *blue_value, gint left, guint width);
void gribouy_grid_update (GribouyGrid *grid, double x1, double y1,
		double x2, double y2);
void gribouy_grid_construct (GribouyGrid *grid);

#endif
