/* Gribouy : A type1 font editor
 * Copyright (C) 2003  David BOUCHER
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __GRIBOUY_LETTER_WINDOW_H__
#define __GRIBOUY_LETTER_WINDOW_H__

#include <glib.h>
#include <glib-object.h>
#include <gnome.h>

#include "gribouy-type1.h"

#define GRIBOUY_TYPE_LETTER_WINDOW	(gribouy_letter_window_get_type())
#define GRIBOUY_LETTER_WINDOW(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_letter_window_get_type(), GribouyLetterWindow)
#define GRIBOUY_LETTER_WINDOW_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_letter_window_get_type(), GribouyLetterWindow const)
#define GRIBOUY_LETTER_WINDOW_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), gribouy_letter_window_get_type(), GribouyLetterWindowClass)
#define GRIBOUY_IS_LETTER_WINDOW(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gribouy_letter_window_get_type ())

#define GRIBOUY_LETTER_WINDOW_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), gribouy_letter_window_get_type(), GribouyLetterWindowClass)

typedef struct _GribouyLetterWindow GribouyLetterWindow;
typedef struct _GribouyLetterWindowClass GribouyLetterWindowClass;

typedef enum {
	TOOL_NONE,
	TOOL_LINE,
} GribouyTool;

struct _GribouyLetterWindow {
	GtkWindow parent;

	char *letter_name;
	GtkWidget *h_ruler, *v_ruler;
	GtkWidget *h_scrollbar, *v_scrollbar;
	GribouyType1 *font;
	GtkWidget *canvas;
	GnomeCanvasItem *letter;
	GnomeCanvasItem *grid;
	GribouyTool tool;
	ArtPoint pt;
	double zoom; 
};

struct _GribouyLetterWindowClass {
	GtkWindowClass parent;

	void (* changed) (GribouyLetterWindow *window, gboolean v);
	void (* need_grid) (GribouyLetterWindow *window, double x1, double y1, double x2, double y2);
};


GType	gribouy_letter_window_get_type (void);
GtkWidget *gribouy_letter_window_new (char *title, GribouyType1 *font);

#endif
