/* Gribouy : A type1 font editor
 * Copyright (C) 2003  David BOUCHER
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __GRIBOUY_LETTER_H__
#define __GRIBOUY_LETTER_H__

#include <gdk/gdk.h>
#include <gtk/gtkobject.h>
#include <math.h>

#include "gribouy-object.h"

#define GRIBOUY_TYPE_LETTER	(gribouy_letter_get_type())
#define GRIBOUY_LETTER(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_letter_get_type(), GribouyLetter)
#define GRIBOUY_LETTER_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_letter_get_type(), GribouyLetter const)
#define GRIBOUY_LETTER_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), gribouy_letter_get_type(), GribouyLetterClass)
#define GRIBOUY_IS_LETTER(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gribouy_letter_get_type ())

#define GRIBOUY_LETTER_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), gribouy_letter_get_type(), GribouyLetterClass)

typedef struct _GribouyLetter GribouyLetter;
typedef struct _GribouyLetterClass GribouyLetterClass;

struct _GribouyLetter {
	GribouyObject parent;
	guint width;
	gint left;
};

struct _GribouyLetterClass {
	GribouyObjectClass parent_class;
};


GType gribouy_letter_get_type (void) G_GNUC_CONST;
GribouyObject *gribouy_letter_new_with_art (GribouyLetterWindow *window, gpointer prog, GribouyType1 *font);

void gribouy_letter_moveto (GribouyLetter *letter, ArtPoint *p);
void gribouy_letter_lineto (GribouyLetter *letter, ArtPoint *p);
void gribouy_letter_curveto (GribouyLetter *letter, double x1, double y1, double x2, double y2, double x3, double y3);
void gribouy_letter_closepath (GribouyLetter *letter);
void gribouy_letter_append_point (GribouyObject *letter, ArtPoint *p);
GList *gribouy_letter_save (GribouyLetter *letter);
#endif
