/* Gribouy : A type1 font editor
 * Copyright (C) 2003  David BOUCHER
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __GRIBOUY_STEM_H__
#define __GRIBOUY_STEM_H__

#include <gdk/gdk.h>
#include <gtk/gtkobject.h>
#include <libgnomecanvas/libgnomecanvas.h>

#include "gribouy-letter.h"

#define GRIBOUY_TYPE_STEM	(gribouy_stem_get_type())
#define GRIBOUY_STEM(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_stem_get_type(), GribouyStem)
#define GRIBOUY_STEM_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_stem_get_type(), GribouyStem const)
#define GRIBOUY_STEM_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), gribouy_stem_get_type(), GribouyStemClass)
#define GRIBOUY_IS_STEM(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gribouy_stem_get_type ())
#define GRIBOUY_IS_HSTEM(obj)    (G_TYPE_CHECK_INSTANCE_TYPE((obj), gribouy_stem_get_type ()) && GRIBOUY_STEM(obj)->horiz)
#define GRIBOUY_IS_VSTEM(obj)    (G_TYPE_CHECK_INSTANCE_TYPE((obj), gribouy_stem_get_type ()) && !GRIBOUY_STEM(obj)->horiz)
#define GRIBOUY_STEM_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), gribouy_stem_get_type(), GribouyStemClass)

typedef struct _GribouyStem GribouyStem;
typedef struct _GribouyStemClass GribouyStemClass;

struct _GribouyStem {
	GnomeCanvasRect rect;
	gboolean horiz;

/* 	gdouble x; */
/* 	gdouble y; */
/* 	gint index; */
/* 	GribouyLetter *letter; */
/* 	gpointer line; */
/* 	guint editable : 1; */
/* 	guint pos      : 3; */
};

struct _GribouyStemClass {
	GnomeCanvasRectClass parent_class;

/* 	void (* moved) (GribouyStem *stem, gint pos, gint index); */
/* 	void (* newpos)(GribouyStem *stem); */
};


GtkType	gribouy_stem_get_type	(void);
GnomeCanvasItem *gribouy_stem_new (GnomeCanvasGroup *group, gboolean horiz,
				   double y1, double y2);
#define gribouy_hstem_new(group,y1,y2) gribouy_stem_new ((group), TRUE, (y1), (y2))
#define gribouy_vstem_new(group,x1,x2) gribouy_stem_new ((group), FALSE, (x1), (x2))

#endif
