/* Gribouy : A type1 font editor
 * Copyright (C) 2003  David BOUCHER
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __GRIBOUY_TRIPLET_H__
#define __GRIBOUY_TRIPLET_H__

#include <gdk/gdk.h>
#include <gtk/gtkobject.h>
#include <libgnomecanvas/libgnomecanvas.h>
#include <math.h>

#include "gribouy-letter.h"
#include "gribouy-object.h"

#define GRIBOUY_TYPE_TRIPLET	(gribouy_triplet_get_type())
#define GRIBOUY_TRIPLET(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_triplet_get_type(), GribouyTriplet)
#define GRIBOUY_TRIPLET_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_triplet_get_type(), GribouyTriplet const)
#define GRIBOUY_TRIPLET_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), gribouy_triplet_get_type(), GribouyTripletClass)
#define GRIBOUY_IS_TRIPLET(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gribouy_triplet_get_type ())

#define GRIBOUY_TRIPLET_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), gribouy_triplet_get_type(), GribouyTripletClass)

typedef struct _GribouyTriplet GribouyTriplet;
typedef struct _GribouyTripletClass GribouyTripletClass;

struct _GribouyTriplet {
	GribouyObject parent;
	GribouyObject *ctrl1;
	GribouyObject *ctrl2;
	int index;
	guint linked : 1;
};

struct _GribouyTripletClass {
	GribouyObjectClass parent_class;
};


GType gribouy_triplet_get_type (void) G_GNUC_CONST;
GribouyObject *gribouy_triplet_new (GribouyObject *curve, int index,
				     gdouble x, gdouble y);
GribouyObject *gribouy_triplet_new_with_tangents (GribouyObject *curve,
		int index, gdouble ax, gdouble ay,
		gdouble x, gdouble y, gdouble px, gdouble py);
GribouyObject *gribouy_triplet_new_with_tangent1 (GribouyObject *curve,
		int index, gdouble ax, gdouble ay, gdouble x, gdouble y);
GribouyObject *gribouy_triplet_new_with_tangent2 (GribouyObject *curve,
		int index, gdouble x, gdouble y, gdouble px, gdouble py);
void gribouy_triplet_destroy_tangent1 (GribouyTriplet *triplet);
void gribouy_triplet_destroy_tangent2 (GribouyTriplet *triplet);
#endif
