/* Gribouy : A type1 font editor
 * Copyright (C) 2003  David BOUCHER
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef __GRIBOUY_TYPE1_H__
#define __GRIBOUY_TYPE1_H__

#include <libxml/parser.h>
#include "gribouy-art.h"

#define GRIBOUY_TYPE_TYPE1 (gribouy_type1_get_type())
#define GRIBOUY_TYPE1(obj) G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_type1_get_type(), GribouyType1)
#define GRIBOUY_TYPE1_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gribouy_type1_get_type(), GribouyType1 const)
#define GRIBOUY_TYPE1_CLASS(klass) G_TYPE_CHECK_CLASS_CAST((klass), gribouy_type1_get_type(), GribouyType1Class)
#define GRIBOUY_IS_TYPE1(obj) G_TYPE_CHECK_INSTANCE_TYPE((obj), gribouy_type1_get_type())
#define GRIBOUY_TYPE1_GET_CLASS(obj) G_TYPE_INSTANCE_GET_CLASS((obj), gribouy_type1_get_type(), GribouyType1Class)

typedef struct _GribouyType1 GribouyType1;
typedef struct _GribouyType1Class GribouyType1Class;

struct _GribouyType1 {
	GObject parent;
	xmlDocPtr xmlfont;
	GPtrArray *subroutines;
	GHashTable *symbols;
	char *current;
	gboolean standard_encoding;
};

struct _GribouyType1Class {
	GObjectClass parent;
};

GType gribouy_type1_get_type ();

GObject *gribouy_type1_new_from_file (const char *filename);
GObject *gribouy_type1_new ();
int gribouy_type1_save_file (const char *file, GribouyType1 *font);
void gribouy_type1_remove (GribouyType1 *font, char *symbol);

#endif
